import java.io.*;

public class XDemo {
  public static void main(String args[]) {
    byte[] buffer;

    try {
      // writing:
      {
	ByteArrayOutputStream byteStream = new ByteArrayOutputStream();

	// the better Serialization uses a subclass of
	// ObjectOutputStream (prepended X)
	ObjectOutputStream objectStream  = new XObjectOutputStream(byteStream);

	XDemoObject obj = new XDemoObject();

	// turn object into byte representation
	objectStream.writeObject(obj);
	System.out.println("Object serialized.");

	objectStream.flush();

	// copy byte representation to array
	buffer = byteStream.toByteArray();
      }

      // reading:
      {
	ByteArrayInputStream byteStream = new ByteArrayInputStream(buffer);

	// the better Serialization uses a subclass of
	// ObjectInputStream (prepended X)
	ObjectInputStream objectStream = new XObjectInputStream(byteStream);

	// read object from byte representation
	Object obj = objectStream.readObject();
	System.out.println("Object deserialized.");
      }
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
}
